## ros-noetic-sick-safetyscanners 1.0.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(sick_safetyscanners)

## Use C++11
#add_definitions(-std=c++11)
## By adding -Wall and -Werror, the compiler does not ignore warnings anymore,
## enforcing cleaner code.
add_definitions(-std=c++11 -Wall)
#add_definitions(-std=c++11 -Wall -Werror)

## Find catkin macros and libraries
find_package(catkin REQUIRED
  COMPONENTS
    diagnostic_updater
    dynamic_reconfigure
    message_generation
    roscpp
    sensor_msgs
    std_msgs
)

## Find system libraries
#find_package(Eigen3 REQUIRED)
find_package(Boost REQUIRED COMPONENTS system thread)

generate_dynamic_reconfigure_options(
  config/SickSafetyscannersConfiguration.cfg
)


add_message_files(
  FILES
  ApplicationDataMsg.msg
  ApplicationInputsMsg.msg
  ApplicationOutputsMsg.msg
  DataHeaderMsg.msg
  DerivedValuesMsg.msg
  ExtendedLaserScanMsg.msg
  FieldMsg.msg
  GeneralSystemStateMsg.msg
  IntrusionDataMsg.msg
  IntrusionDatumMsg.msg
  MeasurementDataMsg.msg
  MonitoringCaseMsg.msg
  OutputPathsMsg.msg
  RawMicroScanDataMsg.msg
  ScanPointMsg.msg
)

add_service_files(
  FILES
  FieldData.srv
)

generate_messages(
  DEPENDENCIES
  sensor_msgs
  std_msgs
)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if your package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS
    include
#    ${EIGEN3_INCLUDE_DIR}
  LIBRARIES
    ${PROJECT_NAME}_core
  CATKIN_DEPENDS
    dynamic_reconfigure
    message_runtime
    roscpp
    sensor_msgs
    std_msgs
  DEPENDS
    Boost
)



###########
## Build ##
###########


## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
#  ${EIGEN3_INCLUDE_DIR}
  ${Boost_INCLUDE_DIRS}
)

## Declare a cpp library
add_library(${PROJECT_NAME}_core
  src/SickSafetyscanners.cpp
  src/cola2/ApplicationNameVariableCommand.cpp
  src/cola2/ChangeCommSettingsCommand.cpp
  src/cola2/CloseSession.cpp
  src/cola2/Cola2Session.cpp
  src/cola2/Command.cpp
  src/cola2/ConfigMetadataVariableCommand.cpp
  src/cola2/CreateSession.cpp
  src/cola2/DeviceNameVariableCommand.cpp
  src/cola2/DeviceStatusVariableCommand.cpp
  src/cola2/FieldGeometryVariableCommand.cpp
  src/cola2/FieldHeaderVariableCommand.cpp
  src/cola2/FieldSetsVariableCommand.cpp
  src/cola2/FindMeCommand.cpp
  src/cola2/FirmwareVersionVariableCommand.cpp
  src/cola2/MeasurementCurrentConfigVariableCommand.cpp
  src/cola2/MeasurementPersistentConfigVariableCommand.cpp
  src/cola2/MethodCommand.cpp
  src/cola2/MonitoringCaseTableHeaderVariableCommand.cpp
  src/cola2/MonitoringCaseVariableCommand.cpp
  src/cola2/OrderNumberVariableCommand.cpp
  src/cola2/ProjectNameVariableCommand.cpp
  src/cola2/RequiredUserActionVariableCommand.cpp
  src/cola2/SerialNumberVariableCommand.cpp
  src/cola2/StatusOverviewVariableCommand.cpp
  src/cola2/TypeCodeVariableCommand.cpp
  src/cola2/UserNameVariableCommand.cpp
  src/cola2/VariableCommand.cpp
  src/communication/AsyncTCPClient.cpp
  src/communication/AsyncUDPClient.cpp
  src/data_processing/ParseApplicationData.cpp
  src/data_processing/ParseApplicationNameData.cpp
  src/data_processing/ParseConfigMetadata.cpp
  src/data_processing/ParseData.cpp
  src/data_processing/ParseDataHeader.cpp
  src/data_processing/ParseDatagramHeader.cpp
  src/data_processing/ParseDerivedValues.cpp
  src/data_processing/ParseDeviceName.cpp
  src/data_processing/ParseDeviceStatus.cpp
  src/data_processing/ParseFieldGeometryData.cpp
  src/data_processing/ParseFieldHeaderData.cpp
  src/data_processing/ParseFieldSetsData.cpp
  src/data_processing/ParseFirmwareVersion.cpp
  src/data_processing/ParseGeneralSystemState.cpp
  src/data_processing/ParseIntrusionData.cpp
  src/data_processing/ParseMeasurementCurrentConfigData.cpp
  src/data_processing/ParseMeasurementData.cpp
  src/data_processing/ParseMeasurementPersistentConfigData.cpp
  src/data_processing/ParseMonitoringCaseData.cpp
  src/data_processing/ParseOrderNumber.cpp
  src/data_processing/ParseProjectName.cpp
  src/data_processing/ParseRequiredUserAction.cpp
  src/data_processing/ParseSerialNumber.cpp
  src/data_processing/ParseStatusOverview.cpp
  src/data_processing/ParseTCPPacket.cpp
  src/data_processing/ParseTypeCodeData.cpp
  src/data_processing/ParseUserNameData.cpp
  src/data_processing/TCPPacketMerger.cpp
  src/data_processing/UDPPacketMerger.cpp
  src/datastructure/ApplicationData.cpp
  src/datastructure/ApplicationInputs.cpp
  src/datastructure/ApplicationName.cpp
  src/datastructure/ApplicationOutputs.cpp
  src/datastructure/CommSettings.cpp
  src/datastructure/ConfigData.cpp
  src/datastructure/ConfigMetadata.cpp
  src/datastructure/Data.cpp
  src/datastructure/DatagramHeader.cpp
  src/datastructure/DataHeader.cpp
  src/datastructure/DerivedValues.cpp
  src/datastructure/DeviceName.cpp
  src/datastructure/DeviceStatus.cpp
  src/datastructure/FieldData.cpp
  src/datastructure/FieldSets.cpp
  src/datastructure/FirmwareVersion.cpp
  src/datastructure/GeneralSystemState.cpp
  src/datastructure/IntrusionData.cpp
  src/datastructure/IntrusionDatum.cpp
  src/datastructure/LatestTelegram.cpp
  src/datastructure/MeasurementData.cpp
  src/datastructure/MonitoringCaseData.cpp
  src/datastructure/OrderNumber.cpp
  src/datastructure/PacketBuffer.cpp
  src/datastructure/ParsedPacketBuffer.cpp
  src/datastructure/ProjectName.cpp
  src/datastructure/RequiredUserAction.cpp
  src/datastructure/ScanPoint.cpp
  src/datastructure/SerialNumber.cpp
  src/datastructure/StatusOverview.cpp
  src/datastructure/TypeCode.cpp
  src/datastructure/UserName.cpp
)

## Declare cpp executables
add_executable(${PROJECT_NAME}_node
  nodes/${PROJECT_NAME}_node.cpp
  src/SickSafetyscannersRos.cpp
)

## Add dependencies to exported targets, like ROS msgs or srvs
add_dependencies(${PROJECT_NAME}_core
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
  ${catkin_EXPORTED_TARGETS}
)

add_dependencies(${PROJECT_NAME}_node
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
  ${catkin_EXPORTED_TARGETS}
)

## Specify libraries to link executable targets against
target_link_libraries(${PROJECT_NAME}_core
  ${catkin_LIBRARIES}
)

target_link_libraries(${PROJECT_NAME}_node
  ${PROJECT_NAME}_core
  ${catkin_LIBRARIES}
)

#############
## Install ##
#############

# Mark executables and/or libraries for installation

install(
  TARGETS ${PROJECT_NAME}_core
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(
  TARGETS ${PROJECT_NAME}_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Mark cpp header files for installation
install(
  DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

# Mark other files for installation
install(
  DIRECTORY docs launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

#############
## Testing ##
#############

#if(CATKIN_ENABLE_TESTING)
#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
## Add gtest based cpp test target and link libraries
#catkin_add_gtest(${PROJECT_NAME}-test
#  test/test_ros_package_template.cpp
#  test/AlgorithmTest.cpp)
#endif()

#if(TARGET ${PROJECT_NAME}-test)
#  target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME}_core)
#  endif()

=== debian/changelog ===
ros-noetic-sick-safetyscanners (1.0.8-1buster) buster; urgency=high

  * changed to constant values for the field data
  * changed uint to int for current config data
  * Contributors: Lennart Puck

 -- Lennart Puck <puck@fzi.de>  Mon, 01 Feb 2021 23:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.7-1buster) buster; urgency=high

  * fixed parsing error in current config data
  * added intensity filter
  * fix for out of range while creating output path message
  * Contributors: Heiko, Lennart Puck

 -- Lennart Puck <puck@fzi.de>  Tue, 10 Nov 2020 23:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.6-1buster) buster; urgency=high

  * checking if number beams is correct
  * checking if if all data is present after parsing the header
  * fix for seg fault in measurementdata
  * Remove rqt_reconfigure dep
  * Contributors: Lennart Puck, Rein Appeldoorn

 -- Lennart Puck <puck@fzi.de>  Sun, 20 Sep 2020 22:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.5-1buster) buster; urgency=high

  * fixing correct offset in field geometries
  * Fixed error in reading chars for device name and project name
  * feat(diagnostics): Sensor state diagnostics
    Exposes sensor hardware information and sensor state.
  * Filter out max range values to INF according to REP 117
  * Correct first initialization of m_time_offset
  * boost::asio API changes in 1.70+
  * Catch exceptions by const ref.
  * Fix error_code comparison to int.
  * Contributors: Chad Rockey, Jad Haj Mustafa, Lennart Puck, Mike Purvis, Rein Appeldoorn

 -- Lennart Puck <puck@fzi.de>  Sun, 14 Jun 2020 22:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.4-1buster) buster; urgency=high

  * Fixed Bug with enum for interface type
  * Eoved enums in class
    Enums are not in the class scope where they are used.
    Prevents redefinitions and pollution of namespace.
  * Correctet variable index for username command
  * Typecode read and parsed from variable
  * Used static casts instead of implicit conversion
  * Contributors: Lennart Puck

 -- Lennart Puck <puck@fzi.de>  Sun, 15 Dec 2019 23:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.3-1buster) buster; urgency=high

  * erasing completed frames from map.
  * Fixed error on startup that no scan was visualised
    The fix should prevent the node from starting without
    publishing any data. The error appears to be related to
    minor rounding errors, thus setting the resolution smaller then
    the lowest resolution. But not equal start and end angles.
    This should fix issue #11 and #12
  * added initialisation of use_pers_config
  * Merge Pull Request #9
    Removing the possibilities to use the angles from the sensor it self.
    Since dynamic reconfigure can only be set up for one frame.
  * removed tcp port from configuration since it can not be configured in the sensor
  * added parameter to use persistent config
  * Added methods to request persistent data from sensor
  * added all parameters to launch file
  * updated persistent and current config command and parser to use config data instead of field data
  * removed unused end angle from field data
  * added datastructure for configs
  * Fix issue with m_angle_offset.  Remove use_sick_angles
  * Use C++ STL to reduce risk of memory corruption
  * Change ReadWriteHelper to namespace functions instead of a stateless class
  * Contributors: Chad Rockey, Jonathan Meyer, Lennart Puck, NicolasLoeffler

 -- Lennart Puck <puck@fzi.de>  Sun, 14 Jul 2019 22:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.2-1buster) buster; urgency=high

  * Read the start angle of the field data from the persistent config instead of the current config
  * Changed to 0 angle being at the front of the scan
  * Allow system to choose the host udp port from the ephemeral range.  Resolve typo -> IPAdress to IPAddress
  * Changed default frame_id name to scan
  * Change publish_frequency parameter to be skip parameter.
  * Add time_offset parameter to adjust scan system timestamps
  * Added median reflector bit in message and code
  * Added active case number to the service call
  * Field data is returned as a vector for all fields
  * Added publisher und service server for field data and output paths
  * Added Start angle and beam resolution to field data

 -- Lennart Puck <puck@fzi.de>  Mon, 14 Jan 2019 23:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.1-1buster) buster; urgency=high

  * Initial Release

 -- Lennart Puck <puck@fzi.de>  Tue, 30 Oct 2018 23:00:00 -0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-sick-safetyscanners//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install

## ros-noetic-sick-safetyscanners 1.0.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -49,7 +49,9 @@
 
 add_service_files(
   FILES
+  ConfigMetadata.srv
   FieldData.srv
+  StatusOverview.srv
 )
 
 generate_messages(
@@ -245,7 +247,9 @@
 install(
   DIRECTORY include/${PROJECT_NAME}/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
-  FILES_MATCHING PATTERN "*.h"
+  FILES_MATCHING
+    PATTERN "*.h"
+    PATTERN "*.hpp"
 )
 
 # Mark other files for installation

=== debian/changelog ===
ros-noetic-sick-safetyscanners (1.0.9-1focal) focal; urgency=high

  * added StatusOverview service
  * added ConfigMetadata service
  * add application and contamination errors to diagnostics
  * add checksums to diagnostics
  * add firmware version to diagnostics
  * Add missing map include.
  * adjusted readme for multicast and interface IP
  * adjusted launch file for interface IP
  * allowing to define multicast IPs from ROS
  * added .hpp to install directive in CMakeList
  * Contributors: Christian Wurm, Ivor Wanders, Lennart Puck, Rein Appeldoorn, Tom de Winter, Yannick de Hoop

 -- Lennart Puck <puck@fzi.de>  Wed, 31 May 2023 22:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.8-1focal) focal; urgency=high

  * changed to constant values for the field data
  * changed uint to int for current config data
  * Contributors: Lennart Puck

 -- Lennart Puck <puck@fzi.de>  Mon, 01 Feb 2021 23:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.7-1focal) focal; urgency=high

  * fixed parsing error in current config data
  * added intensity filter
  * fix for out of range while creating output path message
  * Contributors: Heiko, Lennart Puck

 -- Lennart Puck <puck@fzi.de>  Tue, 10 Nov 2020 23:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.6-1focal) focal; urgency=high

  * checking if number beams is correct
  * checking if if all data is present after parsing the header
  * fix for seg fault in measurementdata
  * Remove rqt_reconfigure dep
  * Contributors: Lennart Puck, Rein Appeldoorn

 -- Lennart Puck <puck@fzi.de>  Sun, 20 Sep 2020 22:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.5-1focal) focal; urgency=high

  * fixing correct offset in field geometries
  * Fixed error in reading chars for device name and project name
  * feat(diagnostics): Sensor state diagnostics
    Exposes sensor hardware information and sensor state.
  * Filter out max range values to INF according to REP 117
  * Correct first initialization of m_time_offset
  * boost::asio API changes in 1.70+
  * Catch exceptions by const ref.
  * Fix error_code comparison to int.
  * Contributors: Chad Rockey, Jad Haj Mustafa, Lennart Puck, Mike Purvis, Rein Appeldoorn

 -- Lennart Puck <puck@fzi.de>  Sun, 14 Jun 2020 22:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.4-1focal) focal; urgency=high

  * Fixed Bug with enum for interface type
  * Eoved enums in class
    Enums are not in the class scope where they are used.
    Prevents redefinitions and pollution of namespace.
  * Correctet variable index for username command
  * Typecode read and parsed from variable
  * Used static casts instead of implicit conversion
  * Contributors: Lennart Puck

 -- Lennart Puck <puck@fzi.de>  Sun, 15 Dec 2019 23:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.3-1focal) focal; urgency=high

  * erasing completed frames from map.
  * Fixed error on startup that no scan was visualised
    The fix should prevent the node from starting without
    publishing any data. The error appears to be related to
    minor rounding errors, thus setting the resolution smaller then
    the lowest resolution. But not equal start and end angles.
    This should fix issue #11 and #12
  * added initialisation of use_pers_config
  * Merge Pull Request #9
    Removing the possibilities to use the angles from the sensor it self.
    Since dynamic reconfigure can only be set up for one frame.
  * removed tcp port from configuration since it can not be configured in the sensor
  * added parameter to use persistent config
  * Added methods to request persistent data from sensor
  * added all parameters to launch file
  * updated persistent and current config command and parser to use config data instead of field data
  * removed unused end angle from field data
  * added datastructure for configs
  * Fix issue with m_angle_offset.  Remove use_sick_angles
  * Use C++ STL to reduce risk of memory corruption
  * Change ReadWriteHelper to namespace functions instead of a stateless class
  * Contributors: Chad Rockey, Jonathan Meyer, Lennart Puck, NicolasLoeffler

 -- Lennart Puck <puck@fzi.de>  Sun, 14 Jul 2019 22:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.2-1focal) focal; urgency=high

  * Read the start angle of the field data from the persistent config instead of the current config
  * Changed to 0 angle being at the front of the scan
  * Allow system to choose the host udp port from the ephemeral range.  Resolve typo -> IPAdress to IPAddress
  * Changed default frame_id name to scan
  * Change publish_frequency parameter to be skip parameter.
  * Add time_offset parameter to adjust scan system timestamps
  * Added median reflector bit in message and code
  * Added active case number to the service call
  * Field data is returned as a vector for all fields
  * Added publisher und service server for field data and output paths
  * Added Start angle and beam resolution to field data

 -- Lennart Puck <puck@fzi.de>  Mon, 14 Jan 2019 23:00:00 -0000

ros-noetic-sick-safetyscanners (1.0.1-1focal) focal; urgency=high

  * Initial Release

 -- Lennart Puck <puck@fzi.de>  Tue, 30 Oct 2018 23:00:00 -0000

=== debian/control ===
Source: ros-noetic-sick-safetyscanners
Section: misc
Priority: optional
Maintainer: Lennart Puck <puck@fzi.de>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-diagnostic-updater, ros-noetic-dynamic-reconfigure, ros-noetic-message-generation, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-sick-safetyscanners
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-diagnostic-updater, ros-noetic-dynamic-reconfigure, ros-noetic-message-runtime, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs
Description: Provides an Interface to read the sensor output of a SICK Safety Scanner

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
